#!/usr/bin/env bash

sleep 10
php /var/www/html/pme/index.php --task=ReleaseReservedJobs > /home/akkadianuser/logs/beanstalkd.log 2>&1
beanstalkdWithNoLog="/home/akkadianuser/scripts/beanstalk/beanstalkd_with_no_binlog"
beanstalkdWithLog="/home/akkadianuser/scripts/beanstalk/beanstalkd"
lockFile="/var/lib/beanstalkd/binlog/lock"
beanstalkdConfigDestination="/etc/sysconfig/beanstalkd"
beanstalkdRestart="/home/akkadianuser/scripts/beanstalk/restartBeanstalk.sh"
beanstalkdStop="/home/akkadianuser/scripts/beanstalk/stopBeanstalk.sh"

if [ -f $lockFile ]; then
        echo "Changing file ownership to apache:apache to all files inside binlog" > /home/akkadianuser/logs/beanstalkd.log 2>&1
        sudo chown apache:apache /var/lib/beanstalkd/binlog/*
        sleep 1
        echo "Changing permissions to binlog files to 777 new one will be generated anyway later on" > /home/akkadianuser/logs/beanstalkd.log 2>&1
        sudo chmod 777 /var/lib/beanstalkd/binlog/binlog.*
        sleep 1
        echo "Removing beanstalkd binlogs files" > /home/akkadianuser/logs/beanstalkd.log 2>&1
        sudo rm /var/lib/beanstalkd/binlog/binlog.* -fvr | sudo tee -a /home/akkadianuser/logs/beanstalkd.log 2>&1
        sleep 1
        echo "Change ownership back to original ownership" >> /home/akkadianuser/logs/beanstalkd.log 2>&1
        sleep 1
        sudo chown beanstalkd:beanstalkd /var/lib/beanstalkd/binlog/*
fi

sudo cp $beanstalkdWithNoLog $beanstalkdConfigDestination -f
sleep 1
echo "cp of beanstalkd with no logs succeeded" >> /home/akkadianuser/logs/beanstalkd.log 2>&1
sudo sh $beanstalkdRestart
sleep 2
echo "sh restarting beanstalkd" >> /home/akkadianuser/logs/beanstalkd.log 2>&1
sudo cp $beanstalkdWithLog $beanstalkdConfigDestination -f
sleep 2
echo "cp beanstalkd with logs succeeded" >> /home/akkadianuser/logs/beanstalkd.log 2>&1
sudo sh $beanstalkdRestart
sleep 2
echo "sh restarting beanstalkd" >> /home/akkadianuser/logs/beanstalkd.log 2>&1
