#!/bin/bash

#systemctl stop nginx
#systemctl disable nginx

isUpgrade="false"
result=$(nginx -v 2>&1 |  sed "s/nginx version:/ /")





if [[ $result == *"1.21.0"* ]] || [[ $result == *"1.21.1"* ]] || [[ $result == *"1.21.2"* ]] || [[ $result == *"1.21.3"* ]] || [[ $result == *"1.21.4"* ]]; then
	isUpgrade="true"
fi



if [[ $isUpgrade == "false" ]]; then

	result=$(systemctl status nginx);


	if [[ $result == *"Loaded: loaded"* ]]; then

		#Active: inactive (dead)
		#Active: active (running)
		if [[ $result == *"Active: active (running)"* ]]; then
			result=$(systemctl stop nginx);
			result=$(systemctl disable nginx);
		fi
		echo " NGINX----- : Service Stopped"


		if [ ! -d "/etc/nginx-backup/" ]; then
			mkdir /etc/nginx-backup/
			cp -r /etc/nginx/* /etc/nginx-backup/
			echo " NGINX----- : Backup done"
		fi
		

		result=$(yum remove nginx -y)

		
		if [[ $result == *"Complete!"* ]]; then
			echo " NGINX----- : Removed"


			rm -rf /etc/nginx
			rm -rf /var/log/nginx
			rm -rf /var/cache/nginx/
			rm -rf /usr/lib/systemd/system/nginx.service
			rm -rf /usr/lib/systemd/system/nginx-debug.service
			echo " NGINX----- : Directories cleaned"


			if [ ! -f "/etc/yum.repos.d/nginx.repo" ]; then
				cp /home/akkadianuser/scripts/upgrade_nginx/nginx.repo /etc/yum.repos.d/
				echo " NGINX----- : Nginx repo copied"
			fi

			
			result=$(yum install nginx -y)
			if [[ $result == *"Complete!"* ]]; then

				echo " NGINX----- : Installed new version"

				result=$(systemctl status nginx);


				if [[ $result == *"Loaded: loaded"* ]]; then


					result=$(systemctl stop nginx);


					cp /etc/nginx-backup/nginx.conf /etc/nginx/
					cp /etc/nginx-backup/mime.types /etc/nginx/

					result=$(systemctl enable nginx)
					result=$(systemctl start nginx);
					result=$(systemctl status nginx);

					if [[ $result == *"Active: active (running)"* ]]; then
						echo " NGINX----- : Service running"
					else
						echo " NGINX----- : Service could not started"
					fi
					
				else

					echo " NGINX----- : Service not loaded"
				fi
			else

				echo " NGINX----- : Could not be installed"

			fi

		else
			echo " NGINX----- : Could not removed"
		fi

	else


		echo " NGINX----- : No old nginx version found "	


	fi

	result=$(nginx -v 2>&1 |  sed "s/nginx version:/ /")

	echo -e " NGINX----- : was upgraded to ${result}"
else

	echo -e " NGINX----- : ${result} is already upgraded"
fi

