import configparser
import subprocess
from subprocess import PIPE

import click
from asm_management import is_asm_installed
from cdr_management import is_cdr_installed

mapper = configparser.RawConfigParser()
mapper.read('mapper.ini')


def handle_general_menu_selection_manager(char, menu, installed_app):
    if char == 'b':
        menu = 'main'
    elif char == '4':
        menu = 'asm_menu' 
    elif char == '5':
        menu = 'cdr_menu'
    elif installed_app == 'aco':
        menu = 'aco_services'
    elif installed_app == 'pme_cm':
        menu = 'pme_services'
    else:
        menu = 'cm_services'

    return menu


def render_general_view_products_menu():
    cdr_installed = is_cdr_installed()
    asm_installed = is_asm_installed()
    click.clear()
    click.secho('Products Settings', fg='green')
    click.secho('1: Akkadian PM/HCS Services', fg='green')
    click.secho('2: Akkadian Console Operator Services', fg='green')
    click.secho('3: Akkadian Contact Manager Services', fg='green')
    if asm_installed:
        click.secho('4: Akkadian Service Monitor', fg='green')
    if cdr_installed:
        click.secho('5: Akkadian CDR Collector', fg='green')
    click.secho('b: Back to Main Menu', fg='red')
    click.secho('You can press \'CTRL+C\' at any time to exit from an action\n'
                'and return to the previous menu.', fg='yellow')
