# Please apply your changes into the product pre-script.sh
if [[ -d /opt/akkadian/aco-server/ ]]; then
    base=$(echo "/home/akkadianuser/universal_installer_scripts/post-scripts/")
else
    base=$(echo "/var/www/product_update/scripts/")
fi

# Modify this script if it has to be applied to all products.
sh $base"001_general_postscript.sh"

if [[ -d /var/www/html/pme ]]; then
    #list here all pme scripts
    sh $base"001_aPM_postscript.sh"
fi

if [[ -d /var/www/html/acm ]]; then
    sh $base"001_aCM_postscript.sh"
fi


if [[ -d /var/www/html/orc ]]; then
    sh $base"001_orc_postscript.sh"
    sh $base"001_hcs_laravel_postscript.sh orc"
fi

if [[ -d /var/www/html/asb ]]; then
    sh $base"001_asb_postscript.sh"
    sh $base"001_hcs_laravel_postscript.sh asb"
fi

if [[ -d /var/www/html/maestro ]]; then
    sh $base"001_maestro_postscript.sh"
    sh $base"001_hcs_laravel_postscript.sh maestro"
fi

if [[ -d /opt/akkadian/aco-server ]]; then
    sh $base"001_aCO_postscript.sh"
fi

# deleting folders used to install because security implemented.
sudo rm -Rf /home/akkadianuser/universal_installer_scripts/
sudo rm -Rf /home/akkadianuser/universal_updater_package/

sudo rm -Rf /home/akkadianuser/netifaces-0.10.4/
sudo rm -Rf /home/akkadianuser/akkadianAppManager.egg-info
sudo rm -Rf /home/akkadianuser/build
sudo rm -Rf /home/akkadianuser/tmp/*


# Create a new if branch if a new product has to be installed.
# if [[ new_product ]]; then
#   001_newproduct-postscript.sh
# fi

# Here the actions block ends

############ This finishes the update script and should always come last. ############################################################
echo "1" > /home/akkadianuser/scripts/universal_updater/run_finish_update_main
sudo cp /home/akkadianuser/scripts/executor/akkadian-executor.service /etc/systemd/system/
systemctl daemon-reload
systemctl enable akkadian-executor
#This will cause us to exit the script.
systemctl restart akkadian-executor
######################################################################################################################################

#kick_out all current cli users, so we avoid the unsecure condition of being in the ova with akkadianuser access.
#sh /home/akkadianuser/scripts/logout.sh