#!/usr/bin/env bash

BASE="/home/akkadianuser/packages/"
VERSION="1.0.3"
RELEASE="3"

RPM_FILENAME="AkkadianServiceMonitor-"$VERSION"-"$RELEASE".noarch.rpm"
RPM_PATH=$BASE"$RPM_FILENAME"

if [[ -f $RPM_PATH && -s $RPM_PATH ]]; then
    # run install but suppress output
    sudo yum -y install $RPM_PATH &> /dev/null
fi

if (($? == 0)); then
    echo "Successfully installed ASM Version: ${VERSION}-${RELEASE}" >>/var/www/product_update/update.log
elif (($? == 1)); then

    # run install again and see if it's caused by nothing to do error.
    sudo yum -y install $RPM_PATH 2>&1 | tee /tmp/asm_install_log &>/dev/null #install and send output to tmp file. ignore output from tee
    grep -q "Error: Nothing to do" /tmp/asm_install_log

    if (($? == 0)); then #same version installed. Process as success
        echo "Skipping installation of ASM Version: ${VERSION}-${RELEASE}, Same or newer version installed." >>/var/www/product_update/update.log
    else
        echo "Installation failed for ASM Version: ${VERSION}-${RELEASE}" >>/var/www/product_update/update.log
    fi

else
    echo "Installation failed for ASM Version: ${VERSION}-${RELEASE}" >>/var/www/product_update/update.log
fi
